Index: trunk/src/VBox/Frontends/VirtualBox/src/UITakeSnapshotDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/UITakeSnapshotDialog.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/UITakeSnapshotDialog.cpp	(revision 108591)
@@ -307,5 +307,5 @@
             connect(m_pButtonBox->button(QIDialogButtonBox::Help), &QPushButton::pressed,
                     m_pButtonBox, &QIDialogButtonBox::sltHandleHelpRequest);
-            uiCommon().setHelpKeyword(m_pButtonBox->button(QIDialogButtonBox::Help), "snapshots");
+            uiCommon().setHelpKeyword(m_pButtonBox->button(QIDialogButtonBox::Help), "snapshots" /* help keyword */);
 
             /* Add into layout: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp	(revision 108591)
@@ -1101,5 +1101,5 @@
     sltRetranslateUI();
     updateModelColumVisibilityCache();
-    uiCommon().setHelpKeyword(this, "vm-activity-overview");
+    uiCommon().setHelpKeyword(this, "vm-activity-overview" /* help keyword */);
     connect(&uiCommon(), &UICommon::sigAskToCommitData,
             this, &UIVMActivityOverviewWidget::sltSaveSettings);
Index: trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp	(revision 108591)
@@ -1083,5 +1083,5 @@
     , m_enmEmbedding(enmEmbedding)
 {
-    uiCommon().setHelpKeyword(this, "vm-activity-session-information");
+    uiCommon().setHelpKeyword(this, "vm-activity-session-information" /* help keyword */);
     setContextMenuPolicy(Qt::CustomContextMenu);
     connect(this, &UIVMActivityMonitor::customContextMenuRequested,
Index: trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityToolWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityToolWidget.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityToolWidget.cpp	(revision 108591)
@@ -58,5 +58,5 @@
     , m_pMonitorContainer(0)
 {
-    uiCommon().setHelpKeyword(this, "vm-activity-session-information");
+    uiCommon().setHelpKeyword(this, "vm-activity-session-information" /* help keyword */);
     prepare();
     prepareActions();
Index: trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileDetailsWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileDetailsWidget.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileDetailsWidget.cpp	(revision 108591)
@@ -203,5 +203,5 @@
     /* Update button states finally: */
     updateButtonStates();
-    uiCommon().setHelpKeyword(this, "ovf-cloud-profile-manager");
+    uiCommon().setHelpKeyword(this, "ovf-cloud-profile-manager" /* help keyword */);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/cloud/profilemanager/UICloudProfileManager.cpp	(revision 108591)
@@ -578,5 +578,5 @@
 
     /* Set help keyowrd for context sensitive help: */
-    uiCommon().setHelpKeyword(this, "cloud-using-cloud-profile-manager");
+    uiCommon().setHelpKeyword(this, "cloud-using-cloud-profile-manager" /* help keyword */);
 
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensionpackmanager/UIExtensionPackManager.cpp	(revision 108591)
@@ -374,5 +374,5 @@
 {
     /* Prepare self: */
-    uiCommon().setHelpKeyword(this, "ext-pack-manager");
+    uiCommon().setHelpKeyword(this, "ext-pack-manager" /* help keyword */);
 
     /* Prepare stuff: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp	(revision 108591)
@@ -144,5 +144,5 @@
     restorePanelVisibility();
     UIFileManagerOptions::create();
-    uiCommon().setHelpKeyword(this, "guestadd-gc-file-manager");
+    uiCommon().setHelpKeyword(this, "guestadd-gc-file-manager" /* help keyword */);
 
     if (!comMachine.isNull())
Index: trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerWidget.cpp	(revision 108591)
@@ -690,5 +690,5 @@
             this, &UIVMLogViewerWidget::sltRetranslateUI);
 
-    uiCommon().setHelpKeyword(this, "log-viewer");
+    uiCommon().setHelpKeyword(this, "log-viewer" /* help keyword */);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIHomePane.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIHomePane.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIHomePane.cpp	(revision 108591)
@@ -226,5 +226,5 @@
 
     /* Assign Help keyword: */
-    uiCommon().setHelpKeyword(this, "intro-starting");
+    uiCommon().setHelpKeyword(this, "intro-starting" /* help keyword */);
 
     /* Translate finally: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp	(revision 108591)
@@ -62,5 +62,5 @@
 
     /* Configure context-sensitive help: */
-    uiCommon().setHelpKeyword(this, "vm-details-tool");
+    uiCommon().setHelpKeyword(this, "vm-details-tool" /* help keyword */);
 
     /* Init model finally: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIFDCreationDialog.cpp	(revision 108591)
@@ -267,5 +267,5 @@
         if (m_pButtonBox)
         {
-            uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "create-floppy-disk-image");
+            uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "create-floppy-disk-image" /* help keyword */);
             connect(m_pButtonBox, &QDialogButtonBox::accepted, this, &UIFDCreationDialog::accept);
             connect(m_pButtonBox, &QDialogButtonBox::rejected, this, &UIFDCreationDialog::reject);
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 108591)
@@ -758,5 +758,5 @@
             sltHandleMediumEnumerationFinish();
     }
-    uiCommon().setHelpKeyword(this,"virtual-media-manager");
+    uiCommon().setHelpKeyword(this,"virtual-media-manager" /* help keyword */);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/viso/UIVisoCreator.cpp	(revision 108591)
@@ -838,5 +838,5 @@
 
 
-    uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "create-optical-disk-image");
+    uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "create-optical-disk-image" /* help keyword */);
 
     sltRetranslateUI();
Index: trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/networkmanager/UINetworkManager.cpp	(revision 108591)
@@ -1720,5 +1720,5 @@
 {
     /* Prepare self: */
-    uiCommon().setHelpKeyword(this, "network-manager");
+    uiCommon().setHelpKeyword(this, "network-manager" /* help keyword */);
 
     /* Prepare stuff: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIVMCloseDialog.cpp	(revision 108591)
@@ -524,5 +524,5 @@
         connect(pButtonBox, &QIDialogButtonBox::accepted, this, &UIVMCloseDialog::accept);
         connect(pButtonBox, &QIDialogButtonBox::rejected, this, &UIVMCloseDialog::reject);
-        uiCommon().setHelpKeyword(pButtonBox->button(QIDialogButtonBox::Help), "intro-save-machine-state");
+        uiCommon().setHelpKeyword(pButtonBox->button(QIDialogButtonBox::Help), "intro-save-machine-state" /* help keyword */);
         connect(pButtonBox->button(QIDialogButtonBox::Help), &QPushButton::pressed,
                 pButtonBox, &QIDialogButtonBox::sltHandleHelpRequest);
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 108591)
@@ -276,5 +276,5 @@
         /* Configure button-box: */
         m_pButtonBox->setStandardButtons(QDialogButtonBox::Close | QDialogButtonBox::Help);
-        uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "vm-session-information");
+        uiCommon().setHelpKeyword(m_pButtonBox->button(QDialogButtonBox::Help), "vm-session-information" /* help keyword */);
         connect(m_pButtonBox, &QIDialogButtonBox::rejected, this, &UIVMInformationDialog::sigClose);
         connect(m_pButtonBox->button(QDialogButtonBox::Help), &QPushButton::pressed,
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp	(revision 108591)
@@ -198,5 +198,5 @@
                     addItem(":/machine_32px.png", ":/machine_24px.png", ":/machine_16px.png",
                             iPageIndex, "#general", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences");
+                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
                     break;
                 }
@@ -207,5 +207,5 @@
                     addItem(":/keyboard_32px.png", ":/keyboard_24px.png", ":/keyboard_16px.png",
                             iPageIndex, "#input", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences");
+                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
                     break;
                 }
@@ -217,5 +217,5 @@
                     addItem(":/refresh_32px.png", ":/refresh_24px.png", ":/refresh_16px.png",
                             iPageIndex, "#update", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences");
+                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
                     break;
                 }
@@ -227,5 +227,5 @@
                     addItem(":/site_32px.png", ":/site_24px.png", ":/site_16px.png",
                             iPageIndex, "#language", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences");
+                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
                     break;
                 }
@@ -236,5 +236,5 @@
                     addItem(":/vrdp_32px.png", ":/vrdp_24px.png", ":/vrdp_16px.png",
                             iPageIndex, "#display", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences");
+                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
                     break;
                 }
@@ -246,5 +246,5 @@
                     addItem(":/proxy_32px.png", ":/proxy_24px.png", ":/proxy_16px.png",
                             iPageIndex, "#proxy", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "preferences");
+                    addPageHelpKeyword(iPageIndex, "preferences" /* help keyword */);
                     break;
                 }
@@ -631,5 +631,5 @@
                     addItem(":/machine_32px.png", ":/machine_24px.png", ":/machine_16px.png",
                             iPageIndex, "#general", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "generalsettings");
+                    addPageHelpKeyword(iPageIndex, "generalsettings" /* help keyword */);
                     break;
                 }
@@ -640,5 +640,5 @@
                     addItem(":/chipset_32px.png", ":/chipset_24px.png", ":/chipset_16px.png",
                             iPageIndex, "#system", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-system");
+                    addPageHelpKeyword(iPageIndex, "settings-system" /* help keyword */);
                     break;
                 }
@@ -649,5 +649,5 @@
                     addItem(":/vrdp_32px.png", ":/vrdp_24px.png", ":/vrdp_16px.png",
                             iPageIndex, "#display", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-display");
+                    addPageHelpKeyword(iPageIndex, "settings-display" /* help keyword */);
                     break;
                 }
@@ -658,5 +658,5 @@
                     addItem(":/hd_32px.png", ":/hd_24px.png", ":/hd_16px.png",
                             iPageIndex, "#storage", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-storage");
+                    addPageHelpKeyword(iPageIndex, "settings-storage" /* help keyword */);
                     break;
                 }
@@ -667,5 +667,5 @@
                     addItem(":/sound_32px.png", ":/sound_24px.png", ":/sound_16px.png",
                             iPageIndex, "#audio", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-audio");
+                    addPageHelpKeyword(iPageIndex, "settings-audio" /* help keyword */);
                     break;
                 }
@@ -676,5 +676,5 @@
                     addItem(":/nw_32px.png", ":/nw_24px.png", ":/nw_16px.png",
                             iPageIndex, "#network", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "settings-network");
+                    addPageHelpKeyword(iPageIndex, "settings-network" /* help keyword */);
                     break;
                 }
@@ -685,5 +685,5 @@
                     addItem(":/serial_port_32px.png", ":/serial_port_24px.png", ":/serial_port_16px.png",
                             iPageIndex, "#serialPorts", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "serialports");
+                    addPageHelpKeyword(iPageIndex, "serialports" /* help keyword */);
                     break;
                 }
@@ -694,5 +694,5 @@
                     addItem(":/usb_32px.png", ":/usb_24px.png", ":/usb_16px.png",
                             iPageIndex, "#usb", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "usb-support");
+                    addPageHelpKeyword(iPageIndex, "usb-support" /* help keyword */);
                     break;
                 }
@@ -703,5 +703,5 @@
                     addItem(":/sf_32px.png", ":/sf_24px.png", ":/sf_16px.png",
                             iPageIndex, "#sharedFolders", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "shared-folders");
+                    addPageHelpKeyword(iPageIndex, "shared-folders" /* help keyword */);
                     break;
                 }
@@ -712,5 +712,5 @@
                     addItem(":/interface_32px.png", ":/interface_24px.png", ":/interface_16px.png",
                             iPageIndex, "#userInterface", pSettingsPage);
-                    addPageHelpKeyword(iPageIndex, "user-interface");
+                    addPageHelpKeyword(iPageIndex, "user-interface" /* help keyword */);
                     break;
                 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotPane.cpp	(revision 108591)
@@ -1328,5 +1328,5 @@
 
     /* Register help topic: */
-    uiCommon().setHelpKeyword(this, "snapshots");
+    uiCommon().setHelpKeyword(this, "snapshots" /* help keyword */);
 
     /* Apply language settings: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 108591)
@@ -3988,5 +3988,5 @@
     loadSettings();
     configure();
-    uiCommon().setHelpKeyword(this, "soft-keyb");
+    uiCommon().setHelpKeyword(this, "soft-keyb" /* help keyword */);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 108588)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 108591)
@@ -111,5 +111,5 @@
             if (!m_strInitialISOFilePath.isEmpty())
                 pNamePage->setISOFilePath(m_strInitialISOFilePath);
-            m_iUnattendedInstallPageIndex = addPage(new UIWizardNewVMUnattendedPage("create-vm-wizard-unattended-install"));
+            m_iUnattendedInstallPageIndex = addPage(new UIWizardNewVMUnattendedPage("create-vm-wizard-unattended-install" /* help keyword */));
             setUnattendedPageVisible(false);
             addPage(new UIWizardNewVMHardwarePage("create-vm-wizard-hardware" /* help keyword*/));