Index: trunk/doc/manual/en_US/dita/UserManual.ditamap
===================================================================
--- trunk/doc/manual/en_US/dita/UserManual.ditamap	(revision 108297)
+++ trunk/doc/manual/en_US/dita/UserManual.ditamap	(revision 108599)
@@ -4,5 +4,6 @@
 <bookmap id="EN-VBOX-7-2-USER" xml:lang="en-US">
    <booktitle>
-      <mainbooktitle>Oracle VirtualBox: User Guide for Release 7.1</mainbooktitle>
+    <booklibrary>Oracle VirtualBox</booklibrary>
+    <mainbooktitle>User Guide for Release 7.2</mainbooktitle>
    </booktitle>
    <bookmeta>
@@ -10,6 +11,6 @@
          <published>
             <completed>
-          <month>December</month>
-          <year>2024</year>
+          <month>March</month>
+          <year>2025</year>
         </completed>
       </published>
@@ -88,22 +89,20 @@
             <topicref href="topics/solaris-zones.dita"/>
          </topicref>
-         <topicref href="topics/install-ext-pack.dita">
-            <topicref href="topics/install-ext-pack-manager.dita"/>
-         </topicref>
     <topicref href="topics/intro-starting.dita"/>
   </chapter>
   <chapter href="topics/configuring-virtualbox.dita" chunk="to-content">
+    <topicref href="topics/extensions.dita">
+      <topicref href="topics/install-ext-pack.dita"/>
+      <topicref href="topics/uninstall-ext-pack.dita"/>
+    </topicref>
     <topicref href="topics/preferences.dita"/>
     <topicref href="topics/ui-experience-level.dita"/>
-    <topicref href="topics/gui-tools-global.dita"/>
       </chapter>
-  <chapter href="topics/create-vm-wizard.dita" chunk="to-content">
-    <topicref href="topics/create-vm-wizard-name-os.dita"/>
-    <topicref href="topics/create-vm-wizard-unattended-install.dita"/>
-    <topicref href="topics/create-vm-wizard-hardware.dita"/>
-    <topicref href="topics/create-vm-wizard-virtual-hard-disk.dita"/>
-         <topicref href="topics/basic-unattended.dita">
+  <chapter href="topics/create-vm.dita" chunk="to-content">
+    <topicref href="topics/create-vm-name-os.dita"/>
+    <topicref href="topics/create-vm-unattended-install.dita"/>
+    <topicref href="topics/create-vm-hardware.dita"/>
+    <topicref href="topics/create-vm-virtual-hard-disk.dita"/>
             <topicref href="topics/unattended-guest-install-example.dita"/>
-         </topicref>
   </chapter>
   <chapter href="topics/BasicConcepts.dita" chunk="to-content">
@@ -278,4 +277,9 @@
       </chapter>
       <chapter href="topics/networkingdetails.dita" chunk="to-content">
+    <topicref href="topics/config-network.dita">
+      <topicref href="topics/create-network.dita"/>
+      <topicref href="topics/remove-network.dita"/>
+      <topicref href="topics/edit-network.dita"/>
+    </topicref>
          <topicref href="topics/nichardware.dita"/>
          <topicref href="topics/networkingmodes.dita"/>
@@ -286,4 +290,13 @@
          </topicref>
          <topicref href="topics/network_nat_service.dita"/>
+    <topicref href="topics/changenat.dita">
+      <topicref href="topics/nat-address-config.dita"/>
+      <topicref href="topics/nat-adv-tftp.dita"/>
+      <topicref href="topics/nat-adv-dns.dita"/>
+      <topicref href="topics/nat_host_resolver_proxy.dita">
+        <topicref href="topics/nat_host_resolver_name_intercepting.dita"/>
+      </topicref>
+      <topicref href="topics/nat-adv-alias.dita"/>
+    </topicref>
          <topicref href="topics/network_bridged.dita"/>
          <topicref href="topics/network_internal.dita"/>
@@ -292,9 +305,4 @@
          <topicref href="topics/network_vde.dita"/>
          <topicref href="topics/network_cloud.dita"/>
-         <topicref href="topics/network-manager.dita">
-            <topicref href="topics/network-manager-host-only-tab.dita"/>
-            <topicref href="topics/network-manager-nat-network-tab.dita"/>
-            <topicref href="topics/network-manager-cloud-network-tab.dita"/>
-         </topicref>
          <topicref href="topics/network_bandwidth_limit.dita"/>
          <topicref href="topics/network_performance.dita"/>
@@ -356,6 +364,4 @@
          <topicref href="topics/nat-address-config.dita"/>
          <topicref href="topics/nat-adv-tftp.dita"/>
-         <topicref href="topics/nat-adv-settings.dita"/>
-         <topicref href="topics/nat-bind-sockets.dita"/>
          <topicref href="topics/nat-adv-dns.dita"/>
          <topicref href="topics/nat_host_resolver_proxy.dita">
@@ -498,4 +504,5 @@
       </topicref>
       <topicref href="topics/ts_lin-x11-guests.dita">
+        <topicref href="topics/ts_rebuild-modules-guest.dita"/>
         <topicref href="topics/guestadd-resizing-linux-limitations.dita"/>
       </topicref>
@@ -512,4 +519,5 @@
       </topicref>
       <topicref href="topics/ts_lin-hosts.dita">
+        <topicref href="topics/ts_rebuild-modules-host.dita"/>
          <topicref href="topics/ts_linux-kernelmodule-fails-to-load.dita"/>
          <topicref href="topics/ts_linux-host-cd-dvd-not-found.dita"/>