Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp	(revision 108656)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp	(revision 108663)
@@ -205,44 +205,4 @@
 }
 
-void UIGlobalToolsWidget::sltHandleCloudMachineStateChange(const QUuid &uId)
-{
-    /* Acquire current item: */
-    UIVirtualMachineItem *pItem = machineToolsWidget()->currentItem();
-    const bool fCurrentItemIsOk = machineToolsWidget()->isItemAccessible(pItem);
-
-    /* If current item is Ok: */
-    if (fCurrentItemIsOk)
-    {
-        /* If Error-pane is chosen currently => switch to tool currently chosen in tools-menu: */
-        if (toolPaneMachine()->currentTool() == UIToolType_Error)
-            machineToolsWidget()->switchToolTo(toolMenu()->toolsType(UIToolClass_Machine));
-
-        /* If we still have same item selected: */
-        if (pItem && pItem->id() == uId)
-        {
-            /* Propagate current items to update the Details-pane: */
-            toolPaneMachine()->setItems(machineToolsWidget()->currentItems());
-        }
-    }
-    else
-    {
-        /* Make sure Error pane raised: */
-        if (toolPaneMachine()->currentTool() != UIToolType_Error)
-            toolPaneMachine()->openTool(UIToolType_Error);
-
-        /* If we still have same item selected: */
-        if (pItem && pItem->id() == uId)
-        {
-            /* Propagate current items to update the Details-pane (in any case): */
-            toolPaneMachine()->setItems(machineToolsWidget()->currentItems());
-            /* Propagate last access error to update the Error-pane (if machine selected but inaccessible): */
-            toolPaneMachine()->setErrorDetails(pItem->accessError());
-        }
-    }
-
-    /* Pass the signal further: */
-    emit sigCloudMachineStateChange(uId);
-}
-
 void UIGlobalToolsWidget::sltHandleGlobalToolMenuUpdate()
 {
@@ -410,6 +370,4 @@
     connect(chooser(), &UIChooser::sigCloudProfileStateChange,
             this, &UIGlobalToolsWidget::sltHandleCloudProfileStateChange);
-    connect(chooser(), &UIChooser::sigCloudMachineStateChange,
-            this, &UIGlobalToolsWidget::sltHandleCloudMachineStateChange);
 
     /* Tools-menu connections: */
@@ -458,6 +416,4 @@
     disconnect(chooser(), &UIChooser::sigCloudProfileStateChange,
                this, &UIGlobalToolsWidget::sltHandleCloudProfileStateChange);
-    disconnect(chooser(), &UIChooser::sigCloudMachineStateChange,
-               this, &UIGlobalToolsWidget::sltHandleCloudMachineStateChange);
 
     /* Tools-menu connections: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.h	(revision 108656)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.h	(revision 108663)
@@ -65,10 +65,4 @@
     /** @} */
 
-    /** @name Chooser pane stuff.
-      * @{ */
-        /** Notifies about state change for cloud machine with certain @a uId. */
-        void sigCloudMachineStateChange(const QUuid &uId);
-    /** @} */
-
 public:
 
@@ -140,7 +134,4 @@
         void sltHandleCloudProfileStateChange(const QString &strProviderShortName,
                                               const QString &strProfileName);
-
-        /** Handles state change for cloud machine with certain @a uId. */
-        void sltHandleCloudMachineStateChange(const QUuid &uId);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.cpp	(revision 108656)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.cpp	(revision 108663)
@@ -298,4 +298,44 @@
 }
 
+void UIMachineToolsWidget::sltHandleCloudMachineStateChange(const QUuid &uId)
+{
+    /* Acquire current item: */
+    UIVirtualMachineItem *pItem = currentItem();
+    const bool fCurrentItemIsOk = isItemAccessible(pItem);
+
+    /* If current item is Ok: */
+    if (fCurrentItemIsOk)
+    {
+        /* If Error-pane is chosen currently => switch to tool currently chosen in tools-menu: */
+        if (toolPane()->currentTool() == UIToolType_Error)
+            switchToolTo(toolMenu()->toolsType(UIToolClass_Machine));
+
+        /* If we still have same item selected: */
+        if (pItem && pItem->id() == uId)
+        {
+            /* Propagate current items to update the Details-pane: */
+            toolPane()->setItems(currentItems());
+        }
+    }
+    else
+    {
+        /* Make sure Error pane raised: */
+        if (toolPane()->currentTool() != UIToolType_Error)
+            toolPane()->openTool(UIToolType_Error);
+
+        /* If we still have same item selected: */
+        if (pItem && pItem->id() == uId)
+        {
+            /* Propagate current items to update the Details-pane (in any case): */
+            toolPane()->setItems(currentItems());
+            /* Propagate last access error to update the Error-pane (if machine selected but inaccessible): */
+            toolPane()->setErrorDetails(pItem->accessError());
+        }
+    }
+
+    /* Pass the signal further: */
+    emit sigCloudMachineStateChange(uId);
+}
+
 void UIMachineToolsWidget::sltHandleToolMenuUpdate(UIVirtualMachineItem *pItem)
 {
@@ -457,4 +497,6 @@
     connect(chooser(), &UIChooser::sigToolMenuRequested,
             this, &UIMachineToolsWidget::sltHandleToolMenuRequested);
+    connect(chooser(), &UIChooser::sigCloudMachineStateChange,
+            this, &UIMachineToolsWidget::sltHandleCloudMachineStateChange);
     connect(chooser(), &UIChooser::sigToggleStarted,
             toolPane(), &UIToolPane::sigToggleStarted);
@@ -510,4 +552,6 @@
     disconnect(chooser(), &UIChooser::sigToolMenuRequested,
                this, &UIMachineToolsWidget::sltHandleToolMenuRequested);
+    disconnect(chooser(), &UIChooser::sigCloudMachineStateChange,
+               this, &UIMachineToolsWidget::sltHandleCloudMachineStateChange);
     disconnect(chooser(), &UIChooser::sigToggleStarted,
                toolPane(), &UIToolPane::sigToggleStarted);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.h	(revision 108656)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.h	(revision 108663)
@@ -71,4 +71,7 @@
         /** Notifies about Chooser-pane selection change. */
         void sigChooserPaneSelectionChange();
+
+        /** Notifies about state change for cloud machine with certain @a uId. */
+        void sigCloudMachineStateChange(const QUuid &uId);
     /** @} */
 
@@ -185,4 +188,7 @@
         /** Handles signal about Chooser-pane selection invalidated. */
         void sltHandleChooserPaneSelectionInvalidated();
+
+        /** Handles state change for cloud machine with certain @a uId. */
+        void sltHandleCloudMachineStateChange(const QUuid &uId);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxWidget.cpp	(revision 108656)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxWidget.cpp	(revision 108663)
@@ -461,6 +461,4 @@
     connect(globalToolsWidget(), &UIGlobalToolsWidget::sigToolTypeChange,
             this, &UIVirtualBoxWidget::sigToolTypeChangeGlobal);
-    connect(globalToolsWidget(), &UIGlobalToolsWidget::sigCloudMachineStateChange,
-            this, &UIVirtualBoxWidget::sigCloudMachineStateChange);
     /* Global Tool Pane connections: */
     connect(globalToolPane(), &UIToolPane::sigCreateMedium,
@@ -478,4 +476,6 @@
     connect(machineToolsWidget(), &UIMachineToolsWidget::sigChooserPaneSelectionChange,
             this, &UIVirtualBoxWidget::sltUpdateToolbar);
+    connect(machineToolsWidget(), &UIMachineToolsWidget::sigCloudMachineStateChange,
+            this, &UIVirtualBoxWidget::sigCloudMachineStateChange);
     /* Machine Tool Pane connections: */
     connect(machineToolPane(), &UIToolPane::sigLinkClicked,
@@ -718,6 +718,4 @@
     disconnect(globalToolsWidget(), &UIGlobalToolsWidget::sigToolTypeChange,
                this, &UIVirtualBoxWidget::sigToolTypeChangeGlobal);
-    disconnect(globalToolsWidget(), &UIGlobalToolsWidget::sigCloudMachineStateChange,
-               this, &UIVirtualBoxWidget::sigCloudMachineStateChange);
     /* Global Tool Pane connections: */
     disconnect(globalToolPane(), &UIToolPane::sigCreateMedium,
@@ -735,4 +733,6 @@
     disconnect(machineToolsWidget(), &UIMachineToolsWidget::sigChooserPaneSelectionChange,
                this, &UIVirtualBoxWidget::sltUpdateToolbar);
+    disconnect(machineToolsWidget(), &UIMachineToolsWidget::sigCloudMachineStateChange,
+               this, &UIVirtualBoxWidget::sigCloudMachineStateChange);
     /* Machine Tool Pane connections: */
     disconnect(machineToolPane(), &UIToolPane::sigLinkClicked,