Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 108663)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 108664)
@@ -292,10 +292,4 @@
         case UIToolType_Machines:
         case UIToolType_Managers:
-        case UIToolType_Extensions:
-        case UIToolType_Media:
-        case UIToolType_Network:
-        case UIToolType_Cloud:
-        case UIToolType_CloudConsole:
-        case UIToolType_Activities:
             return UIToolClass_Global;
         case UIToolType_Error:
@@ -306,4 +300,11 @@
         case UIToolType_FileManager:
             return UIToolClass_Machine;
+        case UIToolType_Extensions:
+        case UIToolType_Media:
+        case UIToolType_Network:
+        case UIToolType_Cloud:
+        case UIToolType_CloudConsole:
+        case UIToolType_Activities:
+            return UIToolClass_Management;
         default:
             break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 108663)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 108664)
@@ -958,10 +958,4 @@
     UIToolType_Machines,
     UIToolType_Managers,
-    UIToolType_Extensions,
-    UIToolType_Media,
-    UIToolType_Network,
-    UIToolType_Cloud,
-    UIToolType_CloudConsole,
-    UIToolType_Activities,
     /* Machine types: */
     UIToolType_Error,
@@ -970,5 +964,12 @@
     UIToolType_Logs,
     UIToolType_VMActivity,
-    UIToolType_FileManager
+    UIToolType_FileManager,
+    /* Management types: */
+    UIToolType_Extensions,
+    UIToolType_Media,
+    UIToolType_Network,
+    UIToolType_Cloud,
+    UIToolType_CloudConsole,
+    UIToolType_Activities
 };
 Q_DECLARE_METATYPE(UIToolType);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp	(revision 108663)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp	(revision 108664)
@@ -125,16 +125,4 @@
     toolPaneManagement()->setActive(enmType == UIToolType_Managers);
 
-    /* Special handling for Activities Global tool,
-     * start unconditionally updating all cloud VMs: */
-    if (enmType == UIToolType_Activities)
-    {
-        chooser()->setKeepCloudNodesUpdated(true);
-        toolPane()->setCloudMachineItems(chooser()->cloudMachineItems());
-    }
-    /* Otherwise, stop unconditionally updating all cloud VMs,
-     * (tho they will still be updated if selected) */
-    else
-        chooser()->setKeepCloudNodesUpdated(false);
-
     /* Let the parent know: */
     emit sigToolTypeChange();
@@ -196,14 +184,72 @@
 void UIGlobalToolsWidget::sltHandleCloudProfileStateChange(const QString &, const QString &)
 {
-    /* If Global Activities tool is currently chosen: */
-    AssertPtrReturnVoid(toolPane());
-    if (toolType() == UIToolType_Activities)
-    {
-        /* Propagate a set of cloud machine items to Global tool-pane: */
-        toolPane()->setCloudMachineItems(chooser()->cloudMachineItems());
+    /* If Management Activities tool is currently chosen: */
+    AssertPtrReturnVoid(toolPaneManagement());
+    if (toolPaneManagement()->currentTool() == UIToolType_Activities)
+    {
+        /* Propagate a set of cloud machine items to Management tool-pane: */
+        toolPaneManagement()->setCloudMachineItems(chooser()->cloudMachineItems());
     }
 }
 
 void UIGlobalToolsWidget::sltHandleGlobalToolMenuUpdate()
+{
+    /* Prepare tool restrictions: */
+    QSet<UIToolType> restrictedTypes;
+
+    /* Make sure Machines tool is hidden for empty Chooser-pane: */
+    if (chooser()->isNavigationListEmpty())
+        restrictedTypes << UIToolType_Machines;
+
+    /* Make sure no restricted tool is selected: */
+    if (restrictedTypes.contains(toolMenu()->toolsType(UIToolClass_Global)))
+        setMenuToolType(UIToolType_Home);
+
+    /* Hide restricted tools in the menu: */
+    const QList restrictions(restrictedTypes.begin(), restrictedTypes.end());
+    toolMenu()->setRestrictedToolTypes(UIToolClass_Global, restrictions);
+
+    /* Close all restricted tools (besides the Machines and Management): */
+    foreach (const UIToolType &enmRestrictedType, restrictedTypes)
+        if (   enmRestrictedType != UIToolType_Machines
+            && enmRestrictedType != UIToolType_Managers)
+            toolPane()->closeTool(enmRestrictedType);
+}
+
+void UIGlobalToolsWidget::sltHandleMachineToolMenuUpdate(UIVirtualMachineItem *pItem)
+{
+    /* Prepare tool restrictions: */
+    QSet<UIToolType> restrictedTypes;
+
+    /* Restrict some types for Basic mode: */
+    const bool fExpertMode = gEDataManager->isSettingsInExpertMode();
+    if (!fExpertMode)
+        restrictedTypes << UIToolType_FileManager;
+
+    /* Make sure local VM tools are hidden for cloud VMs: */
+    if (pItem && pItem->itemType() != UIVirtualMachineItemType_Local)
+        restrictedTypes << UIToolType_Snapshots
+                        << UIToolType_Logs
+                        << UIToolType_FileManager;
+
+    /* Make sure no restricted tool is selected: */
+    if (restrictedTypes.contains(toolMenu()->toolsType(UIToolClass_Machine)))
+        setMenuToolType(UIToolType_Details);
+
+    /* Hide restricted tools in the menu: */
+    const QList restrictions(restrictedTypes.begin(), restrictedTypes.end());
+    toolMenu()->setRestrictedToolTypes(UIToolClass_Machine, restrictions);
+
+    /// @todo finish that
+    // /* Disable even unrestricted tools for inacccessible VMs: */
+    // const bool fCurrentItemIsOk = isItemAccessible(pItem);
+    // toolMenu()->setItemsEnabled(fCurrentItemIsOk);
+
+    /* Close all restricted tools: */
+    foreach (const UIToolType &enmRestrictedType, restrictedTypes)
+        toolPaneMachine()->closeTool(enmRestrictedType);
+}
+
+void UIGlobalToolsWidget::sltHandleManagementToolMenuUpdate()
 {
     /* Prepare tool restrictions: */
@@ -216,62 +262,4 @@
                         << UIToolType_Network;
 
-    /* Make sure Machines tool is hidden for empty Chooser-pane: */
-    if (chooser()->isNavigationListEmpty())
-        restrictedTypes << UIToolType_Machines;
-
-    /* Make sure no restricted tool is selected: */
-    if (restrictedTypes.contains(toolMenu()->toolsType(UIToolClass_Global)))
-        setMenuToolType(UIToolType_Home);
-
-    /* Hide restricted tools in the menu: */
-    const QList restrictions(restrictedTypes.begin(), restrictedTypes.end());
-    toolMenu()->setRestrictedToolTypes(UIToolClass_Global, restrictions);
-
-    /* Close all restricted tools (besides the Machines and Management): */
-    foreach (const UIToolType &enmRestrictedType, restrictedTypes)
-        if (   enmRestrictedType != UIToolType_Machines
-            && enmRestrictedType != UIToolType_Managers)
-            toolPane()->closeTool(enmRestrictedType);
-}
-
-void UIGlobalToolsWidget::sltHandleMachineToolMenuUpdate(UIVirtualMachineItem *pItem)
-{
-    /* Prepare tool restrictions: */
-    QSet<UIToolType> restrictedTypes;
-
-    /* Restrict some types for Basic mode: */
-    const bool fExpertMode = gEDataManager->isSettingsInExpertMode();
-    if (!fExpertMode)
-        restrictedTypes << UIToolType_FileManager;
-
-    /* Make sure local VM tools are hidden for cloud VMs: */
-    if (pItem && pItem->itemType() != UIVirtualMachineItemType_Local)
-        restrictedTypes << UIToolType_Snapshots
-                        << UIToolType_Logs
-                        << UIToolType_FileManager;
-
-    /* Make sure no restricted tool is selected: */
-    if (restrictedTypes.contains(toolMenu()->toolsType(UIToolClass_Machine)))
-        setMenuToolType(UIToolType_Details);
-
-    /* Hide restricted tools in the menu: */
-    const QList restrictions(restrictedTypes.begin(), restrictedTypes.end());
-    toolMenu()->setRestrictedToolTypes(UIToolClass_Machine, restrictions);
-
-    /// @todo finish that
-    // /* Disable even unrestricted tools for inacccessible VMs: */
-    // const bool fCurrentItemIsOk = isItemAccessible(pItem);
-    // toolMenu()->setItemsEnabled(fCurrentItemIsOk);
-
-    /* Close all restricted tools: */
-    foreach (const UIToolType &enmRestrictedType, restrictedTypes)
-        toolPaneMachine()->closeTool(enmRestrictedType);
-}
-
-void UIGlobalToolsWidget::sltHandleManagementToolMenuUpdate()
-{
-    /* Prepare tool restrictions: */
-    QSet<UIToolType> restrictedTypes;
-
     /* Make sure no restricted tool is selected: */
     if (restrictedTypes.contains(toolMenu()->toolsType(UIToolClass_Management)))
@@ -305,7 +293,29 @@
     else if (enmClass == UIToolClass_Machine)
         machineToolsWidget()->switchToolTo(enmType);
-    /* For Management tool class => switch tool-pane accordingly: */
+    /* For Management tool class: */
     else if (enmClass == UIToolClass_Management)
+    {
+        /* Switch tool-pane accordingly: */
         managementToolsWidget()->switchToolTo(enmType);
+
+        /* Special handling for Activities Management tool,
+         * start unconditionally updating all cloud VMs: */
+        if (enmType == UIToolType_Activities)
+        {
+            chooser()->setKeepCloudNodesUpdated(true);
+            toolPaneManagement()->setCloudMachineItems(chooser()->cloudMachineItems());
+        }
+        /* Otherwise, stop unconditionally updating all cloud VMs,
+         * (tho they will still be updated if selected) */
+        else
+            chooser()->setKeepCloudNodesUpdated(false);
+    }
+}
+
+void UIGlobalToolsWidget::sltSwitchToVMActivityTool(const QUuid &uMachineId)
+{
+    AssertPtrReturnVoid(chooser());
+    chooser()->setCurrentMachine(uMachineId);
+    setMenuToolType(UIToolType_VMActivity);
 }
 
@@ -336,5 +346,5 @@
 
         /* Create tool-menu: */
-        m_pMenu = new UITools(this, UIToolClass_Global, actionPool(), Qt::Widget);
+        m_pMenu = new UITools(this, UIToolClass_Invalid, actionPool(), Qt::Widget);
         if (toolMenu())
         {
@@ -380,4 +390,6 @@
     connect(this, &UIGlobalToolsWidget::sigToolMenuUpdate,
             this, &UIGlobalToolsWidget::sltHandleManagementToolMenuUpdate);
+    connect(toolPane(), &UIToolPane::sigSwitchToMachineActivityPane,
+            this, &UIGlobalToolsWidget::sltSwitchToVMActivityTool);
     connect(machineToolsWidget(), &UIMachineToolsWidget::sigToolMenuUpdate,
             this, &UIGlobalToolsWidget::sltHandleMachineToolMenuUpdate);
@@ -426,4 +438,6 @@
     disconnect(this, &UIGlobalToolsWidget::sigToolMenuUpdate,
                this, &UIGlobalToolsWidget::sltHandleManagementToolMenuUpdate);
+    disconnect(toolPane(), &UIToolPane::sigSwitchToMachineActivityPane,
+               this, &UIGlobalToolsWidget::sltSwitchToVMActivityTool);
     disconnect(machineToolsWidget(), &UIMachineToolsWidget::sigToolMenuUpdate,
                this, &UIGlobalToolsWidget::sltHandleMachineToolMenuUpdate);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.h	(revision 108663)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.h	(revision 108664)
@@ -151,4 +151,6 @@
         /** Handles signal requesting switch to Activities tool. */
         void sltSwitchToActivitiesTool();
+        /** Handles signal requesting switch to VM Activity tool. */
+        void sltSwitchToVMActivityTool(const QUuid &uMachineId);
     /** @} */
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.cpp	(revision 108663)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.cpp	(revision 108664)
@@ -39,5 +39,4 @@
 #include "UIMachineToolsWidget.h"
 #include "UIToolPane.h"
-#include "UITools.h"
 #include "UITranslationEventListener.h"
 #include "UIVirtualBoxEventHandler.h"
@@ -52,5 +51,4 @@
     , m_pPaneChooser(0)
     , m_pPaneTools(0)
-    , m_pMenuTools(0)
     , m_enmSelectionType(SelectionType_Invalid)
     , m_fSelectedMachineItemAccessible(false)
@@ -135,21 +133,4 @@
 }
 
-UIToolType UIMachineToolsWidget::menuToolType() const
-{
-    AssertPtrReturn(toolMenu(), UIToolType_Invalid);
-    return toolMenu()->toolsType(UIToolClass_Machine);
-}
-
-void UIMachineToolsWidget::setMenuToolType(UIToolType enmType)
-{
-    /* Sanity check: */
-    AssertReturnVoid(enmType != UIToolType_Invalid);
-    /* Make sure new tool type is of Machine class: */
-    AssertReturnVoid(UIToolStuff::isTypeOfClass(enmType, UIToolClass_Machine));
-
-    AssertPtrReturnVoid(toolMenu());
-    toolMenu()->setToolsType(enmType);
-}
-
 UIToolType UIMachineToolsWidget::toolType() const
 {
@@ -307,7 +288,7 @@
     if (fCurrentItemIsOk)
     {
-        /* If Error-pane is chosen currently => switch to tool currently chosen in tools-menu: */
+        /* If Error-pane is chosen currently => switch to Details: */
         if (toolPane()->currentTool() == UIToolType_Error)
-            switchToolTo(toolMenu()->toolsType(UIToolClass_Machine));
+            switchToolTo(UIToolType_Details);
 
         /* If we still have same item selected: */
@@ -336,72 +317,4 @@
     /* Pass the signal further: */
     emit sigCloudMachineStateChange(uId);
-}
-
-void UIMachineToolsWidget::sltHandleToolMenuUpdate(UIVirtualMachineItem *pItem)
-{
-    /* Prepare tool restrictions: */
-    QSet<UIToolType> restrictedTypes;
-
-    /* Restrict some types for Basic mode: */
-    const bool fExpertMode = gEDataManager->isSettingsInExpertMode();
-    if (!fExpertMode)
-        restrictedTypes << UIToolType_FileManager;
-
-    /* Make sure local VM tools are hidden for cloud VMs: */
-    if (pItem && pItem->itemType() != UIVirtualMachineItemType_Local)
-        restrictedTypes << UIToolType_Snapshots
-                        << UIToolType_Logs
-                        << UIToolType_FileManager;
-
-    /* Make sure no restricted tool is selected: */
-    if (restrictedTypes.contains(toolMenu()->toolsType(UIToolClass_Machine)))
-        setMenuToolType(UIToolType_Details);
-
-    /* Hide restricted tools in the menu: */
-    const QList restrictions(restrictedTypes.begin(), restrictedTypes.end());
-    toolMenu()->setRestrictedToolTypes(UIToolClass_Machine, restrictions);
-
-    /* Disable even unrestricted tools for inacccessible VMs: */
-    const bool fCurrentItemIsOk = isItemAccessible(pItem);
-    toolMenu()->setItemsEnabled(fCurrentItemIsOk);
-
-    /* Close all restricted tools: */
-    foreach (const UIToolType &enmRestrictedType, restrictedTypes)
-        toolPane()->closeTool(enmRestrictedType);
-}
-
-void UIMachineToolsWidget::sltHandleToolMenuRequested(const QPoint &position, UIVirtualMachineItem *pItem)
-{
-    /* Update tools restrictions for item specified: */
-    AssertPtrReturnVoid(pItem);
-    if (pItem)
-        emit sigToolMenuUpdate(pItem);
-
-    /* Compose popup-menu geometry first of all: */
-    QRect ourGeo = QRect(position, toolMenu()->minimumSizeHint());
-    /* Adjust location only to properly fit into available geometry space: */
-    const QRect availableGeo = gpDesktop->availableGeometry(position);
-    ourGeo = gpDesktop->normalizeGeometry(ourGeo, availableGeo, false /* resize? */);
-
-    /* Move, resize and show: */
-    toolMenu()->move(ourGeo.topLeft());
-    toolMenu()->show();
-    // WORKAROUND:
-    // Don't want even to think why, but for Qt::Popup resize to
-    // smaller size often being ignored until it is actually shown.
-    toolMenu()->resize(ourGeo.size());
-}
-
-void UIMachineToolsWidget::sltHandleToolsMenuIndexChange(UIToolType enmType)
-{
-    switchToolTo(enmType);
-}
-
-void UIMachineToolsWidget::sltSwitchToVMActivityTool(const QUuid &uMachineId)
-{
-    AssertPtrReturnVoid(chooser());
-    AssertPtrReturnVoid(toolMenu());
-    chooser()->setCurrentMachine(uMachineId);
-    toolMenu()->setToolsType(UIToolType_VMActivity);
 }
 
@@ -461,7 +374,4 @@
             pLayout->addWidget(m_pSplitter);
         }
-
-        /* Create tools-menu: */
-        m_pMenuTools = new UITools(this, UIToolClass_Machine, actionPool());
     }
 
@@ -482,8 +392,4 @@
             this, &UIMachineToolsWidget::sltHandleSettingsExpertModeChange);
 
-    /* Parent connections: */
-    connect(m_pParent, &UIToolPane::sigSwitchToMachineActivityPane,
-            this, &UIMachineToolsWidget::sltSwitchToVMActivityTool);
-
     /* Splitter connections: */
     connect(m_pSplitter, &QISplitter::splitterMoved,
@@ -495,6 +401,4 @@
     connect(chooser(), &UIChooser::sigSelectionInvalidated,
             this, &UIMachineToolsWidget::sltHandleChooserPaneSelectionInvalidated);
-    connect(chooser(), &UIChooser::sigToolMenuRequested,
-            this, &UIMachineToolsWidget::sltHandleToolMenuRequested);
     connect(chooser(), &UIChooser::sigCloudMachineStateChange,
             this, &UIMachineToolsWidget::sltHandleCloudMachineStateChange);
@@ -503,10 +407,4 @@
     connect(chooser(), &UIChooser::sigToggleFinished,
             toolPane(), &UIToolPane::sigToggleFinished);
-
-    /* Tools-menu connections: */
-    connect(this, &UIMachineToolsWidget::sigToolMenuUpdate,
-            this, &UIMachineToolsWidget::sltHandleToolMenuUpdate);
-    connect(toolMenu(), &UITools::sigSelectionChanged,
-            this, &UIMachineToolsWidget::sltHandleToolsMenuIndexChange);
 }
 
@@ -524,7 +422,4 @@
         m_pSplitter->setSizes(sizes);
     }
-
-    /* Acquire & select tool currently chosen in the menu: */
-    sltHandleToolsMenuIndexChange(toolMenu()->toolsType(UIToolClass_Machine));
 }
 
@@ -537,8 +432,4 @@
                this, &UIMachineToolsWidget::sltHandleSettingsExpertModeChange);
 
-    /* Parent connections: */
-    disconnect(m_pParent, &UIToolPane::sigSwitchToMachineActivityPane,
-               this, &UIMachineToolsWidget::sltSwitchToVMActivityTool);
-
     /* Splitter connections: */
     disconnect(m_pSplitter, &QISplitter::splitterMoved,
@@ -550,6 +441,4 @@
     disconnect(chooser(), &UIChooser::sigSelectionInvalidated,
                this, &UIMachineToolsWidget::sltHandleChooserPaneSelectionInvalidated);
-    disconnect(chooser(), &UIChooser::sigToolMenuRequested,
-               this, &UIMachineToolsWidget::sltHandleToolMenuRequested);
     disconnect(chooser(), &UIChooser::sigCloudMachineStateChange,
                this, &UIMachineToolsWidget::sltHandleCloudMachineStateChange);
@@ -558,15 +447,4 @@
     disconnect(chooser(), &UIChooser::sigToggleFinished,
                toolPane(), &UIToolPane::sigToggleFinished);
-
-    /* Tools-menu connections: */
-    disconnect(this, &UIMachineToolsWidget::sigToolMenuUpdate,
-               this, &UIMachineToolsWidget::sltHandleToolMenuUpdate);
-    disconnect(toolMenu(), &UITools::sigSelectionChanged,
-               this, &UIMachineToolsWidget::sltHandleToolsMenuIndexChange);
-}
-
-UITools *UIMachineToolsWidget::toolMenu() const
-{
-    return m_pMenuTools;
 }
 
@@ -584,7 +462,7 @@
     if (fCurrentItemIsOk)
     {
-        /* If Error-pane is chosen currently => switch to tool currently chosen in tools-menu: */
+        /* If Error-pane is chosen currently => switch to Details: */
         if (toolPane()->currentTool() == UIToolType_Error)
-            switchToolTo(toolMenu()->toolsType(UIToolClass_Machine));
+            switchToolTo(UIToolType_Details);
 
         /* Propagate current items to the Tools pane: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.h	(revision 108663)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIMachineToolsWidget.h	(revision 108664)
@@ -45,5 +45,4 @@
 class UIChooser;
 class UIToolPane;
-class UITools;
 class UIVirtualMachineItem;
 
@@ -129,9 +128,4 @@
         UIToolPane *toolPane() const;
 
-        /** Returns menu tool type. */
-        UIToolType menuToolType() const;
-        /** Defines menu tool @a enmType. */
-        void setMenuToolType(UIToolType enmType);
-
         /** Returns pane tool type. */
         UIToolType toolType() const;
@@ -193,20 +187,4 @@
     /** @} */
 
-    /** @name Tools pane stuff.
-      * @{ */
-        /** Handles request for tools menu update for the @a pItem specified. */
-        void sltHandleToolMenuUpdate(UIVirtualMachineItem *pItem);
-
-        /** Handles tool popup-menu request. */
-        void sltHandleToolMenuRequested(const QPoint &position, UIVirtualMachineItem *pItem);
-
-        /** Handles signal about Tools-menu index change.
-          * @param  enmType  Brings current tool type. */
-        void sltHandleToolsMenuIndexChange(UIToolType enmType);
-
-        /** Handles signal requesting switch to VM Activity tool. */
-        void sltSwitchToVMActivityTool(const QUuid &uMachineId);
-    /** @} */
-
 private:
 
@@ -234,7 +212,4 @@
     /** @name Tools pane stuff.
       * @{ */
-        /** Returns tool-menu instance. */
-        UITools *toolMenu() const;
-
         /** Recaches current machine item information.
           * @param  fDontRaiseErrorPane  Brings whether we should not raise error-pane. */
@@ -253,6 +228,4 @@
     /** Holds the Tools-pane instance. */
     UIToolPane *m_pPaneTools;
-    /** Holds the Tools-menu instance. */
-    UITools    *m_pMenuTools;
 
     /** Holds the last selection type. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxWidget.cpp	(revision 108663)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxWidget.cpp	(revision 108664)
@@ -232,5 +232,5 @@
 {
     AssertPtrReturnVoid(machineToolsWidget());
-    machineToolsWidget()->setMenuToolType(enmType);
+    globalToolsWidget()->setMenuToolType(enmType);
 }
 
@@ -238,5 +238,5 @@
 {
     AssertPtrReturn(machineToolsWidget(), UIToolType_Invalid);
-    return machineToolsWidget()->menuToolType();
+    return globalToolsWidget()->menuToolType(UIToolClass_Machine);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 108663)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 108664)
@@ -1097,12 +1097,12 @@
 {
     /* Prepare variables: */
-    const int iFullWidth = rectangle.width();
+    // const int iFullWidth = rectangle.width();
     const int iFullHeight = rectangle.height();
     const int iMarginHL = data(MachineItemData_MarginHL).toInt();
-    const int iMarginHR = data(MachineItemData_MarginHR).toInt();
+    // const int iMarginHR = data(MachineItemData_MarginHR).toInt();
     const int iMajorSpacing = data(MachineItemData_MajorSpacing).toInt();
     const int iMinorSpacing = data(MachineItemData_MinorSpacing).toInt();
     const int iMachineItemTextSpacing = data(MachineItemData_TextSpacing).toInt();
-    const int iButtonMargin = data(MachineItemData_ButtonMargin).toInt();
+    // const int iButtonMargin = data(MachineItemData_ButtonMargin).toInt();
 
     /* Selected or hovered item foreground: */
@@ -1244,4 +1244,5 @@
     }
 
+#if 0
     /* Calculate indents: */
     QGraphicsView *pView = model()->scene()->views().first();
@@ -1281,4 +1282,5 @@
                     m_toolPixmap);
     }
+#endif
 }
 