Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh	(revision 108668)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh	(revision 108679)
@@ -30,7 +30,7 @@
 LangString VBOX_NOADMIN ${LANG_ENGLISH}                             "You need administrator rights to install or uninstall the $(^Name).$\r$\nThis application will exit now."
 
-LangString VBOX_NOTICE_ARCH_X86 ${LANG_ENGLISH}                     "This application only runs on 32-bit Windows systems. Please pick the variant of the $(^Name) installer matching your guest OS!"
-LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_ENGLISH}                   "This application only runs on 64-bit Windows systems. Please pick the variant of the $(^Name) installer matching your guest OS!"
-LangString VBOX_NOTICE_ARCH_ARM64 ${LANG_ENGLISH}                   "This application only runs on Windows ARM64 systems. Please pick the variant of the $(^Name) installer matching your guest OS!"
+LangString VBOX_NOTICE_ARCH_X86 ${LANG_ENGLISH}                     "This application only runs on 32-bit x86 Windows systems. Please pick the variant of the $(^Name) installer matching your guest OS!"
+LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_ENGLISH}                   "This application only runs on 64-bit x86 Windows systems. Please pick the variant of the $(^Name) installer matching your guest OS!"
+LangString VBOX_NOTICE_ARCH_ARM64 ${LANG_ENGLISH}                   "This application only runs on ARM64 Windows systems. Please pick the variant of the $(^Name) installer matching your guest OS!"
 LangString VBOX_NT4_NO_SP6 ${LANG_ENGLISH}                          "You do not seem to have Service Pack 6 for Windows NT4 installed.$\r$\nWe recommend that you install it first. Do you wish to continue anyway?"
 
Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh	(revision 108668)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh	(revision 108679)
@@ -31,6 +31,6 @@
 
 ;; @todo win.arm64: check spelling of the next three messages.
-LangString VBOX_NOTICE_ARCH_X86 ${LANG_FRENCH}                      "Cette application peut seulement être executée sur des systèmes Windows 32-bit. Veuillez installer la version correspondante de $(^Name)!"
-LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_FRENCH}                    "Cette application peut seulement être executée sur des systèmes Windows 64-bit. Veuillez installer la version correspondante de $(^Name)!"
+LangString VBOX_NOTICE_ARCH_X86 ${LANG_FRENCH}                      "Cette application peut seulement être executée sur des systèmes Windows 32-bit x86. Veuillez installer la version correspondante de $(^Name)!"
+LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_FRENCH}                    "Cette application peut seulement être executée sur des systèmes Windows 64-bit x86. Veuillez installer la version correspondante de $(^Name)!"
 LangString VBOX_NOTICE_ARCH_ARM64 ${LANG_FRENCH}                    "Cette application peut seulement être executée sur des systèmes Windows ARM64. Veuillez installer la version correspondante de $(^Name)!"
 LangString VBOX_NT4_NO_SP6 ${LANG_FRENCH}                           "Le programme d'installation a détécté que vous utilisez Windows NT4 sans Service Pack 6.$\r$\nNous vous conseillons d'installer ce Service Pack avant de continuer. Désirez vous cependant continuer?"
Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh	(revision 108668)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh	(revision 108679)
@@ -31,7 +31,7 @@
 
 ;; @todo win.arm64: Check spelling meaning of the next three messages.
-LangString VBOX_NOTICE_ARCH_X86 ${LANG_GERMAN}                      "Diese Applikation läuft nur auf 32-bit Windows-Systemen. Bitte installieren Sie den passende Version der $(^Name) für Ihren Gast!"
-LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_GERMAN}                    "Diese Applikation läuft nur auf 64-bit Windows-Systemen. Bitte installieren Sie den passende Version der $(^Name) für Ihren Gast!"
-LangString VBOX_NOTICE_ARCH_ARM64 ${LANG_GERMAN}                    "Diese Applikation läuft nur auf Windows-ARM64-Systemen. Bitte installieren Sie den passende Version der $(^Name) für Ihren Gast!"
+LangString VBOX_NOTICE_ARCH_X86 ${LANG_GERMAN}                      "Diese Applikation läuft nur auf 32-bit x86 Windows-Systemen. Bitte installieren Sie den passende Version der $(^Name) für Ihren Gast!"
+LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_GERMAN}                    "Diese Applikation läuft nur auf 64-bit x86 Windows-Systemen. Bitte installieren Sie den passende Version der $(^Name) für Ihren Gast!"
+LangString VBOX_NOTICE_ARCH_ARM64 ${LANG_GERMAN}                    "Diese Applikation läuft nur auf ARM64 Windows-Systemen. Bitte installieren Sie den passende Version der $(^Name) für Ihren Gast!"
 LangString VBOX_NT4_NO_SP6 ${LANG_GERMAN}                           "Es ist kein Service Pack 6 für NT 4.0 installiert.$\r$\nEs wird empfohlen das Service-Pack vor dieser Installation zu installieren. Trotzdem jetzt ohne Service-Pack installieren?"
 