Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp	(revision 108665)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.cpp	(revision 108687)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
+ * Copyright (C) 2012-2025 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
@@ -210,11 +210,4 @@
     AssertPtrReturnVoid(model());
     model()->setCurrentMachineItem(uId);
-}
-
-void UIChooser::sltToolMenuRequested(const QPoint &position, UIVirtualMachineItem *pItem)
-{
-    /* Translate scene coordinates to global one: */
-    AssertPtrReturnVoid(view());
-    emit sigToolMenuRequested(mapToGlobal(view()->mapFromScene(position)), pItem);
 }
 
@@ -277,6 +270,4 @@
 
     /* Chooser-model connections: */
-    connect(model(), &UIChooserModel::sigToolMenuRequested,
-            this, &UIChooser::sltToolMenuRequested);
     connect(model(), &UIChooserModel::sigSelectionChanged,
             this, &UIChooser::sigSelectionChanged);
@@ -327,6 +318,4 @@
 
     /* Chooser-model connections: */
-    disconnect(model(), &UIChooserModel::sigToolMenuRequested,
-               this, &UIChooser::sltToolMenuRequested);
     disconnect(model(), &UIChooserModel::sigSelectionChanged,
                this, &UIChooser::sigSelectionChanged);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h	(revision 108665)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooser.h	(revision 108687)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
+ * Copyright (C) 2012-2025 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
@@ -71,10 +71,4 @@
         /** Notifies listeners about cloud update state change. */
         void sigCloudUpdateStateChanged();
-    /** @} */
-
-    /** @name Tool stuff.
-      * @{ */
-        /** Notifies listeners about tool popup-menu request for certain @a position and optionally machine @a pItem. */
-        void sigToolMenuRequested(const QPoint &position, UIVirtualMachineItem *pItem);
     /** @} */
 
@@ -198,12 +192,4 @@
     /** @} */
 
-private slots:
-
-    /** @name General stuff.
-      * @{ */
-        /** Handles signal about tool popup-menu request for certain @a position and optionally machine @a pItem. */
-        void sltToolMenuRequested(const QPoint &position, UIVirtualMachineItem *pItem);
-    /** @} */
-
 private:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserHandlerMouse.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserHandlerMouse.cpp	(revision 108665)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserHandlerMouse.cpp	(revision 108687)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
+ * Copyright (C) 2012-2025 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
@@ -79,17 +79,5 @@
                 /* Or a machine one? */
                 else if (UIChooserItemMachine *pMachineItem = qgraphicsitem_cast<UIChooserItemMachine*>(pItemUnderMouse))
-                {
-                    const QPoint itemCursorPos = pMachineItem->mapFromScene(scenePos).toPoint();
-                    if (   pMachineItem->isToolButtonArea(itemCursorPos)
-                        && (   model()->firstSelectedItem() == pMachineItem
-                            || pMachineItem->isHovered()))
-                    {
-                        model()->handleToolButtonClick(pMachineItem);
-                        if (model()->firstSelectedItem() != pMachineItem)
-                            pClickedItem = pMachineItem;
-                    }
-                    else
-                        pClickedItem = pMachineItem;
-                }
+                    pClickedItem = pMachineItem;
                 /* If we had clicked one of required item types: */
                 if (pClickedItem && !pClickedItem->isRoot())
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 108665)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 108687)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
+ * Copyright (C) 2012-2025 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
@@ -115,21 +115,4 @@
            && enmState != KMachineState_Aborted
            && enmState != KMachineState_AbortedSaved;
-}
-
-bool UIChooserItemMachine::isToolButtonArea(const QPoint &position, int iMarginMultiplier /* = 1 */) const
-{
-    const int iFullWidth = geometry().width();
-    const int iFullHeight = geometry().height();
-    const int iMarginHR = data(MachineItemData_MarginHR).toInt();
-    const int iButtonMargin = data(MachineItemData_ButtonMargin).toInt();
-    const int iToolPixmapX = iFullWidth - iMarginHR - 1 - m_toolPixmap.width() / m_toolPixmap.devicePixelRatio();
-    const int iToolPixmapY = (iFullHeight - m_toolPixmap.height() / m_toolPixmap.devicePixelRatio()) / 2;
-    QRect rect = QRect(iToolPixmapX,
-                       iToolPixmapY,
-                       m_toolPixmap.width() / m_toolPixmap.devicePixelRatio(),
-                       m_toolPixmap.height() / m_toolPixmap.devicePixelRatio());
-    rect.adjust(-iMarginMultiplier * iButtonMargin, -iMarginMultiplier * iButtonMargin,
-                 iMarginMultiplier * iButtonMargin,  iMarginMultiplier * iButtonMargin);
-    return rect.contains(position);
 }
 
@@ -343,5 +326,4 @@
     const int iMajorSpacing = data(MachineItemData_MajorSpacing).toInt();
     const int iMinorSpacing = data(MachineItemData_MinorSpacing).toInt();
-    const int iButtonMargin = data(MachineItemData_ButtonMargin).toInt();
 
     /* Calculating proposed width: */
@@ -363,7 +345,5 @@
     int iMachineItemWidth = m_pixmapSize.width() +
                             iMajorSpacing +
-                            iMiddleColumnWidth +
-                            iMajorSpacing +
-                            m_toolPixmapSize.width() + 2 * iButtonMargin;
+                            iMiddleColumnWidth;
     iProposedWidth += iMachineItemWidth;
 
@@ -377,5 +357,4 @@
     const int iMarginV = data(MachineItemData_MarginV).toInt();
     const int iMachineItemTextSpacing = data(MachineItemData_TextSpacing).toInt();
-    const int iButtonMargin = data(MachineItemData_ButtonMargin).toInt();
 
     /* Calculating proposed height: */
@@ -391,5 +370,5 @@
                               iBottomLineHeight;
     QList<int> heights;
-    heights << m_pixmapSize.height() << iMiddleColumnHeight << m_toolPixmapSize.height() + 2 * iButtonMargin;
+    heights << m_pixmapSize.height() << iMiddleColumnHeight;
     int iMaxHeight = 0;
     foreach (int iHeight, heights)
@@ -656,5 +635,4 @@
         case MachineItemData_MinorSpacing: return QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize) / 4;
         case MachineItemData_TextSpacing:  return 0;
-        case MachineItemData_ButtonMargin: return QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize) / 4;
 
         /* Default: */
@@ -747,5 +725,4 @@
     const int iMarginHR = data(MachineItemData_MarginHR).toInt();
     const int iMajorSpacing = data(MachineItemData_MajorSpacing).toInt();
-    const int iButtonMargin = data(MachineItemData_ButtonMargin).toInt();
 
     /* Calculate new maximum width for the first row: */
@@ -754,10 +731,4 @@
     iFirstRowMaximumWidth -= m_pixmapSize.width(); /* left pixmap width */
     iFirstRowMaximumWidth -= iMajorSpacing; /* spacing between left pixmap and name(s) */
-    if (   model()->firstSelectedItem() == this
-        || isHovered())
-    {
-        iFirstRowMaximumWidth -= iMajorSpacing; /* spacing between name(s) and right pixmap */
-        iFirstRowMaximumWidth -= m_toolPixmapSize.width() + 2 * iButtonMargin; /* right pixmap width */
-    }
     iFirstRowMaximumWidth -= iMarginHR; /* right margin */
 
@@ -1097,12 +1068,9 @@
 {
     /* Prepare variables: */
-    // const int iFullWidth = rectangle.width();
     const int iFullHeight = rectangle.height();
     const int iMarginHL = data(MachineItemData_MarginHL).toInt();
-    // const int iMarginHR = data(MachineItemData_MarginHR).toInt();
     const int iMajorSpacing = data(MachineItemData_MajorSpacing).toInt();
     const int iMinorSpacing = data(MachineItemData_MinorSpacing).toInt();
     const int iMachineItemTextSpacing = data(MachineItemData_TextSpacing).toInt();
-    // const int iButtonMargin = data(MachineItemData_ButtonMargin).toInt();
 
     /* Selected or hovered item foreground: */
@@ -1243,44 +1211,4 @@
         }
     }
-
-#if 0
-    /* Calculate indents: */
-    QGraphicsView *pView = model()->scene()->views().first();
-    const QPointF sceneCursorPosition = pView->mapToScene(pView->mapFromGlobal(QCursor::pos()));
-    const QPoint itemCursorPosition = mapFromScene(sceneCursorPosition).toPoint();
-    int iRightColumnIndent = iFullWidth - iMarginHR - 1 - m_toolPixmap.width() / m_toolPixmap.devicePixelRatio();
-
-    /* Paint right column: */
-    if (   model()->firstSelectedItem() == this
-        || isHovered())
-    {
-        /* Prepare variables: */
-        const int iToolPixmapX = iRightColumnIndent;
-        const int iToolPixmapY = (iFullHeight - m_toolPixmap.height() / m_toolPixmap.devicePixelRatio()) / 2;
-        QRect toolButtonRectangle = QRect(iToolPixmapX,
-                                          iToolPixmapY,
-                                          m_toolPixmap.width() / m_toolPixmap.devicePixelRatio(),
-                                          m_toolPixmap.height() / m_toolPixmap.devicePixelRatio());
-        toolButtonRectangle.adjust(- iButtonMargin, -iButtonMargin, iButtonMargin, iButtonMargin);
-
-        /* Paint tool button: */
-        if (   isHovered()
-            && isToolButtonArea(itemCursorPosition, 4))
-            paintFlatButton(/* Painter: */
-                            pPainter,
-                            /* Button rectangle: */
-                            toolButtonRectangle,
-                            /* Cursor position: */
-                            itemCursorPosition);
-
-        /* Paint pixmap: */
-        paintPixmap(/* Painter: */
-                    pPainter,
-                    /* Point to paint in: */
-                    QPoint(iToolPixmapX, iToolPixmapY),
-                    /* Pixmap to paint: */
-                    m_toolPixmap);
-    }
-#endif
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 108665)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.h	(revision 108687)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
+ * Copyright (C) 2012-2025 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
@@ -75,7 +75,4 @@
         /** Returns whether VM is locked. */
         bool isLockedMachine() const;
-
-        /** Returns whether passed @a position belongs to tool button area. */
-        bool isToolButtonArea(const QPoint &position, int iMarginMultiplier = 1) const;
     /** @} */
 
@@ -208,5 +205,4 @@
         MachineItemData_MinorSpacing,
         MachineItemData_TextSpacing,
-        MachineItemData_ButtonMargin,
     };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 108665)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 108687)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
+ * Copyright (C) 2012-2025 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
@@ -117,10 +117,4 @@
 {
     return scene() ? scene()->itemAt(position, deviceTransform) : 0;
-}
-
-void UIChooserModel::handleToolButtonClick(UIChooserItem *pItem)
-{
-    emit sigToolMenuRequested(pItem->mapToScene(QPointF(pItem->size().width(), 0)).toPoint(),
-                              pItem->type() == UIChooserNodeType_Machine ? pItem->toMachineItem()->cache() : 0);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 108665)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 108687)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2024 Oracle and/or its affiliates.
+ * Copyright (C) 2012-2025 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
@@ -64,10 +64,4 @@
 signals:
 
-    /** @name Tool stuff.
-      * @{ */
-        /** Notifies listeners about tool popup-menu request for certain @a position and optionally machine @a pItem. */
-        void sigToolMenuRequested(const QPoint &position, UIVirtualMachineItem *pItem);
-    /** @} */
-
     /** @name Selection stuff.
       * @{ */
@@ -118,7 +112,4 @@
         /** Returns item at @a position, taking into account possible @a deviceTransform. */
         QGraphicsItem *itemAt(const QPointF &position, const QTransform &deviceTransform = QTransform()) const;
-
-        /** Handles tool button click for certain @a pItem. */
-        void handleToolButtonClick(UIChooserItem *pItem);
     /** @} */
 