Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp	(revision 108690)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIGlobalToolsWidget.cpp	(revision 108691)
@@ -348,5 +348,5 @@
 
         /* Create tool-menu: */
-        m_pMenu = new UITools(this, UIToolClass_Invalid, actionPool());
+        m_pMenu = new UITools(this, actionPool());
         if (toolMenu())
         {
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.cpp	(revision 108690)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.cpp	(revision 108691)
@@ -39,8 +39,6 @@
 
 UITools::UITools(QWidget *pParent,
-                 UIToolClass enmClass,
                  UIActionPool *pActionPool)
     : QWidget(pParent, Qt::Widget)
-    , m_enmClass(enmClass)
     , m_pActionPool(pActionPool)
     , m_pMainLayout(0)
@@ -116,5 +114,5 @@
 {
     /* Prepare model: */
-    m_pToolsModel = new UIToolsModel(this, m_pActionPool, m_enmClass);
+    m_pToolsModel = new UIToolsModel(this, m_pActionPool);
     if (m_pToolsModel)
         prepareView();
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h	(revision 108690)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UITools.h	(revision 108691)
@@ -61,8 +61,6 @@
 
     /** Constructs Tools-pane passing @a pParent to the base-class.
-      * @param  enmClass     Brings the tools class, it will be fixed one.
       * @param  pActionPool  Brings the action-pool reference. */
     UITools(QWidget *pParent,
-            UIToolClass enmClass,
             UIActionPool *pActionPool);
     /** Destructs Tools-pane. */
@@ -116,7 +114,4 @@
     /** @name General stuff.
       * @{ */
-        /** Holds the tools class. */
-        const UIToolClass  m_enmClass;
-
         /** Holds the action-pool reference. */
         UIActionPool *m_pActionPool;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 108690)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.cpp	(revision 108691)
@@ -363,8 +363,7 @@
 *********************************************************************************************************************************/
 
-UIToolsModel::UIToolsModel(QObject *pParent, UIActionPool *pActionPool, UIToolClass enmClass)
+UIToolsModel::UIToolsModel(QObject *pParent, UIActionPool *pActionPool)
     : QObject(pParent)
     , m_pActionPool(pActionPool)
-    , m_enmClass(enmClass)
     , m_pView(0)
     , m_pScene(0)
@@ -915,24 +914,14 @@
 void UIToolsModel::prepareItems()
 {
-    if (   m_enmClass == UIToolClass_Global
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        /* Home: */
-        m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/welcome_screen_24px.png",
-                                                                ":/welcome_screen_24px.png"),
-                                   UIToolType_Home);
-    }
-
-    if (   m_enmClass == UIToolClass_Global
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        /* Machines: */
-        m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/machine_details_manager_24px.png",
-                                                                ":/machine_details_manager_disabled_24px.png"),
-                                   UIToolType_Machines);
-    }
-
-    if (   m_enmClass == UIToolClass_Machine
-        || m_enmClass == UIToolClass_Invalid)
+    /* Home: */
+    m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/welcome_screen_24px.png",
+                                                            ":/welcome_screen_24px.png"),
+                               UIToolType_Home);
+
+    /* Machines: */
+    m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/machine_details_manager_24px.png",
+                                                            ":/machine_details_manager_disabled_24px.png"),
+                               UIToolType_Machines);
+
     {
         /* Details: */
@@ -962,15 +951,9 @@
     }
 
-    if (   m_enmClass == UIToolClass_Management
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        /* Management: */
-        m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/extension_pack_manager_24px.png",
-                                                                ":/extension_pack_manager_disabled_24px.png"),
-                                   UIToolType_Managers);
-    }
-
-    if (   m_enmClass == UIToolClass_Global
-        || m_enmClass == UIToolClass_Invalid)
+    /* Management: */
+    m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/extension_pack_manager_24px.png",
+                                                            ":/extension_pack_manager_disabled_24px.png"),
+                               UIToolType_Managers);
+
     {
         /* Extensions: */
@@ -1000,12 +983,8 @@
     }
 
-    if (   m_enmClass == UIToolClass_Global
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        /* Toggle: */
-        m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/tools_menu_24px.png",
-                                                                ":/tools_menu_24px.png"),
-                                   UIToolType_Toggle);
-    }
+    /* Toggle: */
+    m_items << new UIToolsItem(scene(), UIIconPool::iconSet(":/tools_menu_24px.png",
+                                                            ":/tools_menu_24px.png"),
+                               UIToolType_Toggle);
 
     /* Calculate overall shifts: */
@@ -1015,6 +994,5 @@
 void UIToolsModel::prepareAnimationEngine()
 {
-    if (m_enmClass == UIToolClass_Invalid)
-        m_pAnimationEngine = new UIToolsAnimationEngine(this);
+    m_pAnimationEngine = new UIToolsAnimationEngine(this);
 }
 
@@ -1037,30 +1015,23 @@
     LogRel2(("GUI: UIToolsModel: Restoring tool items as: Global=%d, Machine=%d, Management=%d\n",
              (int)enmTypeGlobal, (int)enmTypeMachine, (int)enmTypeManagment));
-
-    /* Assign values depending on model class: */
-    if (   m_enmClass == UIToolClass_Global
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        UIToolsItem *pItem = item(enmTypeGlobal);
-        if (!pItem)
-            pItem = item(UIToolType_Home);
-        setCurrentItem(pItem);
-    }
-    if (   m_enmClass == UIToolClass_Machine
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        UIToolsItem *pItem = item(enmTypeMachine);
-        if (!pItem)
-            pItem = item(UIToolType_Details);
-        setCurrentItem(pItem);
-    }
-    if (   m_enmClass == UIToolClass_Management
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        UIToolsItem *pItem = item(enmTypeManagment);
-        if (!pItem)
-            pItem = item(UIToolType_Extensions);
-        setCurrentItem(pItem);
-    }
+    UIToolsItem *pItem = 0;
+
+    /* Global: */
+    pItem = item(enmTypeGlobal);
+    if (!pItem)
+        pItem = item(UIToolType_Home);
+    setCurrentItem(pItem);
+
+    /* Machine: */
+    pItem = item(enmTypeMachine);
+    if (!pItem)
+        pItem = item(UIToolType_Details);
+    setCurrentItem(pItem);
+
+    /* Management: */
+    pItem = item(enmTypeManagment);
+    if (!pItem)
+        pItem = item(UIToolType_Extensions);
+    setCurrentItem(pItem);
 }
 
@@ -1071,23 +1042,11 @@
     gEDataManager->toolsPaneLastItemsChosen(enmTypeGlobal, enmTypeMachine, enmTypeManagment);
 
-    /* Update values depending on model class: */
-    if (   m_enmClass == UIToolClass_Global
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        if (UIToolsItem *pItem = currentItem(UIToolClass_Global))
-            enmTypeGlobal = pItem->itemType();
-    }
-    if (   m_enmClass == UIToolClass_Machine
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        if (UIToolsItem *pItem = currentItem(UIToolClass_Machine))
-            enmTypeMachine = pItem->itemType();
-    }
-    if (   m_enmClass == UIToolClass_Management
-        || m_enmClass == UIToolClass_Invalid)
-    {
-        if (UIToolsItem *pItem = currentItem(UIToolClass_Management))
-            enmTypeManagment = pItem->itemType();
-    }
+    /* Gather actual values, we are going to save them: */
+    if (UIToolsItem *pItem = currentItem(UIToolClass_Global))
+        enmTypeGlobal = pItem->itemType();
+    if (UIToolsItem *pItem = currentItem(UIToolClass_Machine))
+        enmTypeMachine = pItem->itemType();
+    if (UIToolsItem *pItem = currentItem(UIToolClass_Management))
+        enmTypeManagment = pItem->itemType();
 
     /* Save selected items data: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h	(revision 108690)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsModel.h	(revision 108691)
@@ -84,7 +84,6 @@
 
     /** Constructs Tools-model passing @a pParent to the base-class.
-      * @param  pActionPool  Brings the action-pool reference.
-      * @param  enmClass     Brings the tools class, it will be const one. */
-    UIToolsModel(QObject *pParent, UIActionPool *pActionPool, UIToolClass enmClass);
+      * @param  pActionPool  Brings the action-pool reference. */
+    UIToolsModel(QObject *pParent, UIActionPool *pActionPool);
     /** Destructs Tools-model. */
     virtual ~UIToolsModel() RT_OVERRIDE;
@@ -241,7 +240,4 @@
         UIActionPool *m_pActionPool;
 
-        /** Holds the tools class. */
-        const UIToolClass  m_enmClass;
-
         /** Holds the view reference. */
         UIToolsView    *m_pView;